#!/bin/bash
# inspired by https://gitlab.mpi-sws.org/FP/iris-ci/blob/40b71102efe051c777a785035aebcbaa4c2ec19f/buildjob
set -e
set -o pipefail
set -x


# Parepare
. ci/ansi-colors.sh
. ci/prepare-opam.sh $OPAM_PINS # deliberately not quoted
env | egrep '^(CI_BUILD_REF|CI_RUNNER)' > build-env.txt

# Build
echo_color "$BOLDGREEN" "[buildjob] Perfoming build"
time make --output-sync --no-print-directory -k -j$CPU_CORES TIMED=y 2>&1 | tee build-log.txt
if fgrep Axiom build-log.txt >/dev/null; then exit 1; fi
echo_color "$BOLDGREEN" "[buildjob] Build time summary"
cat build-log.txt | egrep "(real|user): [0-9]" | tee build-time.txt
