(** * Substitution lemmas for GQM *)
Require Import GQM.Base.
Require Import GQM.GQM.
Require Import GQM.GQMDeduction.

Lemma gqm_subst : forall A f, |-- A -> |-- (A.[f]).
Proof.
  move => A f.
  remember (max_var A) as n.
  move: f A Heqn.
  elim: n.
  - move => f A Hmaxv Himp.
    rewrite (subst_end _ _ ids_).
    rewrite -Hmaxv.
    (* Set Printing All. *)
    suff ->: ((switch_at O f ids_) = ids_) by [asimpl].
    rewrite /switch_at.
    apply: functional_extensionality => n.
    suff ->: (n <? 0 = false) by [].
    apply/PeanoNat.Nat.ltb_spec0.
    omega.
  - move => n IH f A Hmaxv Himp.
    have H := (gqm_Anec _ Himp); clear Himp.
    have HAmaxv : (n = max_var ([A] A)). {
      move => /=.
      rewrite -Hmaxv.
      omega.
    }
    have H2 := (IH (fun k => f (S k)) _ HAmaxv H); clear H.
    asimpl in H2.
    have H3 := (gqm_mp _ _ (gqm_AE _ (f 0)) H2); clear H2.
    asimpl in H3.
    suff <-: (f 0 .: (fun k : var => f (S k)) = f) by [].
    apply: functional_extensionality => m.
    by case: m.
Qed.