Require Import GQM.Base.
Require Import GQM.GQM.

(** Definition *)

Inductive GQMded: form -> Prop :=
| gqm_I1 A B: GQMded (A ->> B ->> A)
| gqm_I2 A B C: GQMded ((A ->> B ->> C) ->> (A ->> B) ->> A ->> C)
| gqm_I3 A B: GQMded ((-! A ->> -! B) ->> B ->> A)
| gqm_swap A B C: GQMded ((A ->> B ->> C) ->> (B ->> A ->> C))

| gqm_ADist A B: GQMded ([A](A ->> B) ->> ([A]A ->> [A]B))
| gqm_AE A B: GQMded ([A]A ->> (A.[B/]))

| gqm_Aglob A B: GQMded ([A]A ->> [A](A.[B/].[ren (+1)]))
| gqm_Q5 A: GQMded ((-! [A]A) ->> [A]((-![A]A).[ren(+1)]))

| gqm_BoxCon A B: GQMded ([A](A <<->> B) ->> (|[]|A <<->> |[]| B))

| gqm_mp A B: GQMded (A ->> B) -> GQMded A -> GQMded B
 (* no [ren (+1)] here, because p does not have to be fresh *)
| gqm_Anec A: GQMded A -> GQMded ([A]A)
(* the global naming context for the antecedent contains q at 0, whereas it is shifted by one in the consequent and q is removed from the global naming context *)
| gqm_univgen A B: GQMded (A.[ren (+1)] ->> [A]B) -> GQMded (A ->> [A][A]B)
.

Notation "'|--' A"  := (GQMded A) (at level 80, no associativity).
Hint Constructors GQMded : GQMDB.
